Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.api.artifacts
[Java] Interface Configuration

    org.gradle.api.Buildable
      org.gradle.api.tasks.AntBuilderAware
          org.gradle.api.file.FileCollection
              org.gradle.api.artifacts.Configuration

All Superinterfaces:
  Buildable, AntBuilderAware, FileCollection

    public interface Configuration
    extends FileCollection

A `Configuration` represents a group of artifacts and their dependencies.

Nested Class Summary
`enum` | `Configuration.State` The states a configuration can be into.

Method Summary
`Configuration` | `addArtifact(PublishArtifact artifact)` Adds an artifact to be published to this configuration.
`void` | `addDependency(Dependency dependency)` Adds a dependency to this configuration.
`Configuration` | `copy()` Creates a copy of this configuration that only contains the dependencies directly in this configuration (without contributions from superconfigurations).
`Configuration` | `copy(Spec dependencySpec)` Creates a copy of this configuration ignoring superconfigurations (see copy() but filtering the dependencies using the dependencySpec.
`Configuration` | `copy(groovy.lang.Closure dependencySpec)` Takes a closure which gets coerced into a Spec.
`Configuration` | `copyRecursive()` Creates a copy of this configuration that contains the dependencies directly in this configuration and those derived from superconfigurations.
`Configuration` | `copyRecursive(Spec dependencySpec)` Creates a copy of this configuration with dependencies from superconfigurations (see copyRecursive()) but filtering the dependencies using the dependencySpec.
`Configuration` | `copyRecursive(groovy.lang.Closure dependencySpec)` Takes a closure which gets coerced into a Spec.
`Configuration` | `exclude(java.util.Map excludeProperties)` Adds an exclude rule to exclude transitive dependencies for all dependencies of this configuration.
`Configuration` | `extendsFrom(Configuration superConfigs)` Adds the given configurations to the set of configuration which this configuration extends from.
`FileCollection` | `fileCollection(Spec dependencySpec)` Resolves this configuration lazyly.
`FileCollection` | `fileCollection(groovy.lang.Closure dependencySpecClosure)` Takes a closure which gets coerced into a Spec.
`FileCollection` | `fileCollection(Dependency dependencies)` Resolves this configuration lazyly.
`java.util.Set` | `files(groovy.lang.Closure dependencySpecClosure)` Takes a closure which gets coerced into a Spec.
`java.util.Set` | `files(Spec dependencySpec)` Resolves this configuration.
`java.util.Set` | `files(Dependency dependencies)` Resolves this configuration.
`java.util.Set` | `getAll()` Returns all the configurations belonging to the same configuration container as this configuration (including this configuration).
`FileCollection` | `getAllArtifactFiles()` Returns the artifacts of this configuration as a FileCollection, including artifacts of extended configurations.
`java.util.Set` | `getAllArtifacts()` Returns the artifacts of this configuration including the artifacts of extended configurations.
`java.util.Set` | `getAllDependencies()` Gets the complete set of dependencies including those contributed by superconfigurations.
`java.util.Set` | `getAllDependencies(java.lang.Class type)` Gets the set of dependencies of type T for this configuration including those contributed by superconfigurations.
`java.util.Set` | `getArtifacts()` Returns the artifacts of this configuration excluding the artifacts of extended configurations.
`TaskDependency` | `getBuildArtifacts()` Returns a `TaskDependency` object containing all required dependencies to build the artifacts belonging to this configuration or to one of its super configurations.
`TaskDependency` | `getBuildDependencies()` Returns a `TaskDependency` object containing all required dependencies to build the internal dependencies (e.g. project dependencies) belonging to this configuration or to one of its super configurations.
`java.util.Set` | `getDependencies()` Gets the set of dependencies directly contained in this configuration (ignoring superconfigurations).
`java.util.Set` | `getDependencies(java.lang.Class type)` Gets the set of dependencies of type T directly contained in this configuration (ignoring superconfigurations).
`java.lang.String` | `getDescription()` Returns the description for this configuration.
`java.util.Set` | `getExcludeRules()` Returns the exclude rules applied for resolving any dependency of this configuration.
`java.util.Set` | `getExtendsFrom()` Returns the names of the configurations which this configuration extends from.
`java.util.Set` | `getHierarchy()` Gets a ordered set including this configuration and all superconfigurations recursively.
`java.lang.String` | `getName()` Returns the name of this configuration.
`ResolvedConfiguration` | `getResolvedConfiguration()` Resolves this configuration.
`Configuration.State` | `getState()` A `Configuration` represents a group of artifacts and their dependencies.
`TaskDependency` | `getTaskDependencyFromProjectDependency(boolean useDependedOn, java.lang.String taskName)` Returns a TaskDependency object containing dependencies on all tasks with the specified name from project dependencies related to this configuration or one of its super configurations.
`java.lang.String` | `getUploadTaskName()` Returns the name of the task that upload the artifacts of this configuration to repositories declared by the user.
`boolean` | `isTransitive()` Returns the transitivity of this configuration.
`boolean` | `isVisible()` Returns true if this is a visible configuration.
`void` | `publish(java.util.List publishRepositories, java.io.File descriptorDestination)` Publishes the artifacts of this configuration to the specified repositories.
`Configuration` | `removeArtifact(PublishArtifact artifact)` Removes an artifact from the artifacts to be published to this configuration.
`java.util.Set` | `resolve()` Resolves this configuration.
`Configuration` | `setDescription(java.lang.String description)` Sets the description for this configuration.
`Configuration` | `setExtendsFrom(java.util.Set superConfigs)` Sets the configurations which this configuration extends from.
`Configuration` | `setTransitive(boolean t)` Sets the transitivity of this configuration.
`Configuration` | `setVisible(boolean visible)` Sets the visibility of this configuration.

Methods inherited from interface FileCollection
add, addToAntBuilder, addToAntBuilder, asType, contains, filter, filter, getAsFileTree, getAsPath, getFiles, getSingleFile, isEmpty, minus, plus, stopExecutionIfEmpty

Methods inherited from interface Buildable
getBuildDependencies

Methods inherited from interface AntBuilderAware
addToAntBuilder

Methods inherited from interface java.lang.Iterable
java.lang.Iterable#iterator()

Methods inherited from class java.lang.Object
java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#notify(), java.lang.Object#notifyAll(), java.lang.Object#toString()

Method Detail

### addArtifact

    public Configuration addArtifact(PublishArtifact artifact)

  Adds an artifact to be published to this configuration.
  Parameters:
    `artifact` - The artifact.
  Returns:
    this

### addDependency

    public void addDependency(Dependency dependency)

  Adds a dependency to this configuration.
  Parameters:
    `dependency` - The dependency to be added.

### copy

    public Configuration copy()

  Creates a copy of this configuration that only contains the dependencies directly in this configuration (without contributions from superconfigurations). The new configuation will be in the UNRESOLVED state, but will retain all other attributes of this configuration except superconfigurations. getHierarchy() for the copy will not include any superconfigurations.
  Returns:
    copy of this configuration

### copy

    public Configuration copy(Spec dependencySpec)

  Creates a copy of this configuration ignoring superconfigurations (see copy() but filtering the dependencies using the dependencySpec. The dependencySpec may be obtained from DependencySpecs.type() like DependencySpecs.type(Type.EXTERNAL)
  Parameters:
    `dependencySpec` - filtering requirements
  Returns:
    copy of this configuration

### copy

    public Configuration copy(groovy.lang.Closure dependencySpec)

  Takes a closure which gets coerced into a Spec. Behaves otherwise in the same way as copy(org.gradle.api.specs.Spec)
  Parameters:
    `dependencySpec` - filtering requirements
  Returns:
    copy of this configuration

### copyRecursive

    public Configuration copyRecursive()

  Creates a copy of this configuration that contains the dependencies directly in this configuration and those derived from superconfigurations. The new configuration will be in the UNRESOLVED state, but will retain all other attributes of this configuration except superconfigurations. getHierarchy() for the copy will not include any superconfigurations.
  Returns:
    copy of this configuration

### copyRecursive

    public Configuration copyRecursive(Spec dependencySpec)

  Creates a copy of this configuration with dependencies from superconfigurations (see copyRecursive()) but filtering the dependencies using the dependencySpec. The dependencySpec may be obtained from DependencySpecs.type() like DependencySpecs.type(Type.EXTERNAL)
  Parameters:
    `dependencySpec` - filtering requirements
  Returns:
    copy of this configuration

### copyRecursive

    public Configuration copyRecursive(groovy.lang.Closure dependencySpec)

  Takes a closure which gets coerced into a Spec. Behaves otherwise in the same way as copyRecursive(org.gradle.api.specs.Spec)
  Parameters:
    `dependencySpec` - filtering requirements
  Returns:
    copy of this configuration

### exclude

    public Configuration exclude(java.util.Map excludeProperties)

  Adds an exclude rule to exclude transitive dependencies for all dependencies of this configuration. You can also add exclude rules per-dependency. See ModuleDependency.exclude.
  Parameters:
    `excludeProperties` - the properties to define the exclude rule.
  Returns:
    this

### extendsFrom

    public Configuration extendsFrom(Configuration superConfigs)

  Adds the given configurations to the set of configuration which this configuration extends from.
  Parameters:
    `superConfigs` - The super configurations.
  Returns:
    this configuration

### fileCollection

    public FileCollection fileCollection(Spec dependencySpec)

  Resolves this configuration lazyly. The resolve happens when the elements of the returned FileCollection get accessed the first time. This locates and downloads the files which make up this configuration. Only the resulting set of files belonging to the subset of dependencies specified by the dependencySpec is contained in the FileCollection.
  Parameters:
    `dependencySpec` - The spec describing a filter applied to the all the dependencies of this configuration (including dependencies from extended configurations).
  Returns:
    The FileCollection with a subset of dependencies of this configuration.

### fileCollection

    public FileCollection fileCollection(groovy.lang.Closure dependencySpecClosure)

  Takes a closure which gets coerced into a Spec. Behaves otherwise in the same way as fileCollection(org.gradle.api.specs.Spec).
  Parameters:
    `dependencySpecClosure` - The closure describing a filter applied to the all the dependencies of this configuration (including dependencies from extended configurations).
  Returns:
    The FileCollection with a subset of dependencies of this configuration.

### fileCollection

    public FileCollection fileCollection(Dependency dependencies)

  Resolves this configuration lazyly. The resolve happens when the elements of the returned FileCollection get accessed the first time. This locates and downloads the files which make up this configuration. Only the resulting set of files belonging to specified dependencies is contained in the FileCollection.
  Parameters:
    `dependencies` - The dependencies for which the FileCollection should contain the files.
  Returns:
    The FileCollection with a subset of dependencies of this configuration.

### files

    public java.util.Set files(groovy.lang.Closure dependencySpecClosure)

  Takes a closure which gets coerced into a Spec. Behaves otherwise in the same way as files(org.gradle.api.specs.Spec).
  Parameters:
    `dependencySpecClosure` - The closure describing a filter applied to the all the dependencies of this configuration (including dependencies from extended configurations).
  Returns:
    The files of a subset of dependencies of this configuration.

### files

    public java.util.Set files(Spec dependencySpec)

  Resolves this configuration. This locates and downloads the files which make up this configuration. But only the resulting set of files belonging to the subset of dependencies specified by the dependencySpec is returned.
  Parameters:
    `dependencySpec` - The spec describing a filter applied to the all the dependencies of this configuration (including dependencies from extended configurations).
  Returns:
    The files of a subset of dependencies of this configuration.

### files

    public java.util.Set files(Dependency dependencies)

  Resolves this configuration. This locates and downloads the files which make up this configuration. But only the resulting set of files belonging to the specified dependencies is returned.
  Parameters:
    `dependencies` - The dependences to be resolved
  Returns:
    The files of a subset of dependencies of this configuration.

### getAll

    public java.util.Set getAll()

  Returns all the configurations belonging to the same configuration container as this configuration (including this configuration).

### getAllArtifactFiles

    public FileCollection getAllArtifactFiles()

  Returns the artifacts of this configuration as a FileCollection, including artifacts of extended configurations.
  Returns:
    the artifact files.

### getAllArtifacts

    public java.util.Set getAllArtifacts()

  Returns the artifacts of this configuration including the artifacts of extended configurations.

### getAllDependencies

    public java.util.Set getAllDependencies()

  Gets the complete set of dependencies including those contributed by superconfigurations.
  Returns:
    the set of dependencies

### getAllDependencies

    public java.util.Set getAllDependencies(java.lang.Class type)

  Gets the set of dependencies of type T for this configuration including those contributed by superconfigurations.
  Parameters:
    `type` - the dependency type
    `` - the dependency type
  Returns:
    The set. Returns an empty set if there are no such dependencies.

### getArtifacts

    public java.util.Set getArtifacts()

  Returns the artifacts of this configuration excluding the artifacts of extended configurations.

### getBuildArtifacts

    public TaskDependency getBuildArtifacts()

  Returns a `TaskDependency` object containing all required dependencies to build the artifacts belonging to this configuration or to one of its super configurations.
  Returns:
    a task dependency object

### getBuildDependencies

    public TaskDependency getBuildDependencies()

  Returns a `TaskDependency` object containing all required dependencies to build the internal dependencies (e.g. project dependencies) belonging to this configuration or to one of its super configurations.
  Returns:
    a TaskDependency object

### getDependencies

    public java.util.Set getDependencies()

  Gets the set of dependencies directly contained in this configuration (ignoring superconfigurations).
  Returns:
    the set of dependencies

### getDependencies

    public java.util.Set getDependencies(java.lang.Class type)

  Gets the set of dependencies of type T directly contained in this configuration (ignoring superconfigurations).
  Parameters:
    `type` - the dependency type
    `` - the dependency type
  Returns:
    The set. Returns an empty set if there are no such dependencies.

### getDescription

    public java.lang.String getDescription()

  Returns the description for this configuration.
  Returns:
    the description. May be null.

### getExcludeRules

    public java.util.Set getExcludeRules()

  Returns the exclude rules applied for resolving any dependency of this configuration.
  See Also:
    exclude(java.util.Map)

### getExtendsFrom

    public java.util.Set getExtendsFrom()

  Returns the names of the configurations which this configuration extends from. The artifacts of the super configurations are also available in this configuration.
  Returns:
    The super configurations. Returns an empty set when this configuration does not extend any others.

### getHierarchy

    public java.util.Set getHierarchy()

  Gets a ordered set including this configuration and all superconfigurations recursively.
  Returns:
    the list of all configurations

### getName

    public java.lang.String getName()

  Returns the name of this configuration.
  Returns:
    The configuration name, never null.

### getResolvedConfiguration

    public ResolvedConfiguration getResolvedConfiguration()

  Resolves this configuration. This locates and downloads the files which make up this configuration, and returns a ResolvedConfiguration that may be used to determine information about the resolve (including errors).
  Returns:
    The ResolvedConfiguration object

### getState

    public Configuration.State getState()

  A `Configuration` represents a group of artifacts and their dependencies.

### getTaskDependencyFromProjectDependency

    public TaskDependency getTaskDependencyFromProjectDependency(boolean useDependedOn, java.lang.String taskName)

  Returns a TaskDependency object containing dependencies on all tasks with the specified name from project dependencies related to this configuration or one of its super configurations. These other projects may be projects this configuration depends on or projects with a similarly named configuation that depend on this one based on the useDependOn argument.
  Parameters:
    `useDependedOn` - if true, add tasks from project dependencies in this conifguration, otherwise use projects from configurations with the same name that depend on this one.
    `taskName` - name of task to depend on
  Returns:
    the populated TaskDependency object

### getUploadTaskName

    public java.lang.String getUploadTaskName()

  Returns the name of the task that upload the artifacts of this configuration to repositories declared by the user.
  See Also:
    Upload

### isTransitive

    public boolean isTransitive()

  Returns the transitivity of this configuration. A transitive configuration contains the transitive closure of its direct dependencies, and all their dependencies. An intransitive configuration contains only the direct dependencies. The default value is true.
  Returns:
    true if this is a transitive configuration, false otherwise.

### isVisible

    public boolean isVisible()

  Returns true if this is a visible configuration. A visible configuration is usable outside the project it belongs to. The default value is true.
  Returns:
    true if this is a visible configuration.

### publish

    public void publish(java.util.List publishRepositories, java.io.File descriptorDestination)

  Publishes the artifacts of this configuration to the specified repositories. This method is usually used only internally as the users use the associated upload tasks to upload the artifacts.
  Parameters:
    `publishRepositories` - The repositories to publish the artifacts to.
    `descriptorDestination` - The destination dir for the descriptor file (if null no descriptor file is written).
  See Also:
    Upload
    getUploadTaskName()

### removeArtifact

    public Configuration removeArtifact(PublishArtifact artifact)

  Removes an artifact from the artifacts to be published to this configuration.
  Parameters:
    `artifact` - The artifact.
  Returns:
    this

### resolve

    public java.util.Set resolve()

  Resolves this configuration. This locates and downloads the files which make up this configuration, and returns the resulting set of files.
  Returns:
    The files of this configuration.

### setDescription

    public Configuration setDescription(java.lang.String description)

  Sets the description for this configuration.
  Parameters:
    `description` - the description. May be null
  Returns:
    this configuration

### setExtendsFrom

    public Configuration setExtendsFrom(java.util.Set superConfigs)

  Sets the configurations which this configuration extends from.
  Parameters:
    `superConfigs` - The super configuration. Should not be null.
  Returns:
    this configuration

### setTransitive

    public Configuration setTransitive(boolean t)

  Sets the transitivity of this configuration. When set to true, this configuration will contain the transitive closure of its dependencies and their dependencies. The default value is true.
  Parameters:
    `t` - true if this is a transitive configuration.
  Returns:
    this configuration

### setVisible

    public Configuration setVisible(boolean visible)

  Sets the visibility of this configuration. When visible is set to true, this configuration is visibile outside the project it belongs to. The default value is true.
  Parameters:
    `visible` - true if this is a visible configuration
  Returns:
    this configuration

Groovy Documentation